// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.17.0
// source: queries.sql

package db

import (
	"context"
	"database/sql"
)

const insertDependabotEndOfLife = `-- name: InsertDependabotEndOfLife :exec
;


insert into dependabot_endoflife (
  organisation,
  repo,

  package_name,
  version,

  package_manager,
  package_file_path,

  product_name,
  cycle
  ) VALUES (
  ?,
  ?,
  ?,
  ?,
  ?,
  ?,
  ?,
  ?
)
`

type InsertDependabotEndOfLifeParams struct {
	Organisation    string
	Repo            string
	PackageName     string
	Version         string
	PackageManager  string
	PackageFilePath string
	ProductName     string
	Cycle           string
}

// ---------- Dependabot
func (q *Queries) InsertDependabotEndOfLife(ctx context.Context, arg InsertDependabotEndOfLifeParams) error {
	_, err := q.db.ExecContext(ctx, insertDependabotEndOfLife,
		arg.Organisation,
		arg.Repo,
		arg.PackageName,
		arg.Version,
		arg.PackageManager,
		arg.PackageFilePath,
		arg.ProductName,
		arg.Cycle,
	)
	return err
}

const insertProductCycle = `-- name: InsertProductCycle :exec
insert into endoflifedate_products (
  product_name,
  cycle,
  supported_until,
  eol_from,
  inserted_at
  ) VALUES (
  ?,
  ?,
  ?,
  ?,
  ?
)
`

type InsertProductCycleParams struct {
	ProductName    string
	Cycle          string
	SupportedUntil sql.NullString
	EolFrom        sql.NullString
	InsertedAt     string
}

func (q *Queries) InsertProductCycle(ctx context.Context, arg InsertProductCycleParams) error {
	_, err := q.db.ExecContext(ctx, insertProductCycle,
		arg.ProductName,
		arg.Cycle,
		arg.SupportedUntil,
		arg.EolFrom,
		arg.InsertedAt,
	)
	return err
}

const insertRenovateEndOfLife = `-- name: InsertRenovateEndOfLife :exec

insert into renovate_endoflife (
  organisation,
  repo,

  package_name,
  version,

  package_manager,
  package_file_path,

  product_name,
  cycle
  ) VALUES (
  ?,
  ?,
  ?,
  ?,
  ?,
  ?,
  ?,
  ?
)
`

type InsertRenovateEndOfLifeParams struct {
	Organisation    string
	Repo            string
	PackageName     string
	Version         string
	PackageManager  string
	PackageFilePath string
	ProductName     string
	Cycle           string
}

// ---------- Renovate
func (q *Queries) InsertRenovateEndOfLife(ctx context.Context, arg InsertRenovateEndOfLifeParams) error {
	_, err := q.db.ExecContext(ctx, insertRenovateEndOfLife,
		arg.Organisation,
		arg.Repo,
		arg.PackageName,
		arg.Version,
		arg.PackageManager,
		arg.PackageFilePath,
		arg.ProductName,
		arg.Cycle,
	)
	return err
}

const retrieveDependabotEndOfLife = `-- name: RetrieveDependabotEndOfLife :many
select
organisation,
repo,

package_name,
version,
package_manager,
package_file_path,

endoflifedate_products.product_name,
endoflifedate_products.cycle,

supported_until,
eol_from
from
dependabot_endoflife
natural join
endoflifedate_products
`

type RetrieveDependabotEndOfLifeRow struct {
	Organisation    string
	Repo            string
	PackageName     string
	Version         string
	PackageManager  string
	PackageFilePath string
	ProductName     string
	Cycle           string
	SupportedUntil  sql.NullString
	EolFrom         sql.NullString
}

func (q *Queries) RetrieveDependabotEndOfLife(ctx context.Context) ([]RetrieveDependabotEndOfLifeRow, error) {
	rows, err := q.db.QueryContext(ctx, retrieveDependabotEndOfLife)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []RetrieveDependabotEndOfLifeRow
	for rows.Next() {
		var i RetrieveDependabotEndOfLifeRow
		if err := rows.Scan(
			&i.Organisation,
			&i.Repo,
			&i.PackageName,
			&i.Version,
			&i.PackageManager,
			&i.PackageFilePath,
			&i.ProductName,
			&i.Cycle,
			&i.SupportedUntil,
			&i.EolFrom,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const retrieveRenovateEndOfLife = `-- name: RetrieveRenovateEndOfLife :many
select
organisation,
repo,

package_name,
version,
package_manager,
package_file_path,

endoflifedate_products.product_name,
endoflifedate_products.cycle,

supported_until,
eol_from
from
renovate_endoflife
natural  join
endoflifedate_products
`

type RetrieveRenovateEndOfLifeRow struct {
	Organisation    string
	Repo            string
	PackageName     string
	Version         string
	PackageManager  string
	PackageFilePath string
	ProductName     string
	Cycle           string
	SupportedUntil  sql.NullString
	EolFrom         sql.NullString
}

func (q *Queries) RetrieveRenovateEndOfLife(ctx context.Context) ([]RetrieveRenovateEndOfLifeRow, error) {
	rows, err := q.db.QueryContext(ctx, retrieveRenovateEndOfLife)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []RetrieveRenovateEndOfLifeRow
	for rows.Next() {
		var i RetrieveRenovateEndOfLifeRow
		if err := rows.Scan(
			&i.Organisation,
			&i.Repo,
			&i.PackageName,
			&i.Version,
			&i.PackageManager,
			&i.PackageFilePath,
			&i.ProductName,
			&i.Cycle,
			&i.SupportedUntil,
			&i.EolFrom,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
